define DESCRIPTION
Code quality (testing, linting/auto-formatting, etc.) and local execution
orchestration for $(PROJECT_NAME).
endef

#################################################################################
# CONFIGURATIONS                                                                #
#################################################################################

MAKEFLAGS += --warn-undefined-variables
SHELL := bash
.SHELLFLAGS := -eu -o pipefail -c
.DEFAULT_GOAL := help
.DELETE_ON_ERROR:
.SUFFIXES:

#################################################################################
# GLOBALS                                                                       #
#################################################################################

REGISTRY_NAMESPACE = has-sante
PROJECT_DIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
PROJECT_NAME := $(shell basename $(PROJECT_DIR))
DOCKER_REPOSITORY = $(REGISTRY_NAMESPACE)/$(PROJECT_NAME)

# List any changed files (excluding submodules)
CHANGED_FILES := $(shell git diff --name-only)

ifeq ($(strip $(CHANGED_FILES)),)
GIT_VERSION := $(shell git describe --tags --long --always)
else
diff_checksum := $(shell git diff | shasum -a 256 | cut -c -6)
GIT_VERSION := $(shell git describe --tags --long --always --dirty)-$(diff_checksum)
endif
TAG := $(shell date +v%Y%m%d)-$(GIT_VERSION)

IMG := $(DOCKER_REPOSITORY):$(TAG)
LATEST_IMG := $(DOCKER_REPOSITORY):latest
IS_CI := false

# Custom certs may be used on the HAS infrastructure and requests needs to be
# aware of them
REQUESTS_CA_BUNDLE := /etc/ssl/certs/ca-certificates.crt
#################################################################################
# HELPER TARGETS                                                                #
#################################################################################

.PHONY: get-make-var-%
get-make-var-%:
	@echo $($*)

# Check that given variables are set and all have non-empty values,
# die with an error otherwise.
#
# Params:
#   1. Variable name(s) to test.
#   2. (optional) Error message to print.
check_defined = \
	$(strip $(foreach 1,$1, \
		$(call __check_defined,$1,$(strip $(value 2)))))
__check_defined = \
	$(if $(value $1),, \
	  $(error Undefined $1$(if $2, ($2))))

.PHONY: validate_req_env_vars
validate_req_env_vars:
	$(call check_defined, REQ_ENV_VARS, Error: Required list of env vars to validate as defined not set!)
	$(foreach REQ_ENV_VAR,$(REQ_ENV_VARS),$(call check_defined, $(REQ_ENV_VAR), Error: Required env var not set!))

.PHONY: strong-version-tag
strong-version-tag: get-make-var-TAG

.PHONY: strong-version-tag-dateless
strong-version-tag-dateless: get-make-var-GIT_VERSION

.PHONY: update-dependencies
## Install Python dependencies,
## updating packages in `poetry.lock` with any newer versions specified in
## `pyproject.toml`, and install bqss source code
update-dependencies:
	poetry update --lock
ifneq (${IS_CI}, true)
	poetry install --extras docs
endif

.PHONY: generate-requirements
## Generate project requirements.txt files from `pyproject.toml`
generate-requirements:
	poetry export -f requirements.txt --without-hashes > requirements.txt # subset
	poetry export --dev -f requirements.txt --without-hashes > requirements-dev.txt # superset w/o docs
	poetry export --extras docs --dev -f requirements.txt --without-hashes > requirements-all.txt # superset

.PHONY: clean-requirements
## Clean generated project requirements files
clean-requirements:
	find . -maxdepth 1 -type f -name "requirements*.txt" -delete

.PHONY: clean
## Delete all compiled Python files
clean:
	find . -type f -name "*.py[co]" -delete
	find . -type f -name "*.coverage*" -delete
	find . -type d -name "__pycache__" -delete


#################################################################################
# COMMANDS                                                                      #
#################################################################################

## Installation

.PHONY: provision-environment
## Set up Python virtual environment with installed project dependencies
provision-environment:
ifeq ($(shell command -v poetry),)
	@echo "poetry could not be found!"
	@echo "Please install poetry!"
	@echo "Ex.: 'curl -sSL \
	https://raw.githubusercontent.com/python-poetry/poetry/master/install-poetry.py  | python - \
	&& source $$HOME/.local/env'"
	@echo "see:"
	@echo "- https://python-poetry.org/docs/#installation"
	@echo "Note: 'pyenv' recommended for Python version management"
	@echo "see:"
	@echo "- https://github.com/pyenv/pyenv"
	@echo "- https://python-poetry.org/docs/managing-environments/"
	false
else
	poetry install --extras docs -v
endif

.PHONY: install-pre-commit-hooks
## Install git pre-commit hooks locally
install-pre-commit-hooks:
	poetry run pre-commit install

.PHONY: get-project-version-number
## Echo project's canonical version number
get-project-version-number:
	@poetry version --short

# Docker related

.PHONY: docker-build
docker-build: export DOCKER_BUILDKIT=1
## Build bqss container
docker-build:
	docker-compose build bqss

.PHONY: docker-rm
## Stop container forcefully (i.e., when keyboard interrupts are disabled)
docker-rm:
	- docker-compose stop
	- docker-compose rm

.PHONY: docker-run
## Runs the Dockerfile with the default entrypoint
docker-run: docker-build
	docker-compose -f docker-compose.yml run \
	--rm --service-ports bqss

.PHONY: docker-run-interactive
## Runs the Dockerfile with a bash entrypoint
docker-run-interactive: docker-build
	docker-compose -f docker-compose.yml run \
	--rm --service-ports bqss bash


.PHONY: docker-jupyter-run
## Runs the Dockerfile with the jupyter entrypoint
docker-jupyter-run: docker-build
	docker-compose -f docker-compose.yml run \
	--rm --service-ports bqss-notebook

.PHONY: docker-test
## Runs the Dockerfile with the jupyter entrypoint
docker-test: docker-build
	docker-compose -f docker-compose.yml run \
	--rm --service-ports --entrypoint bin/entrypoint.test bqss


.PHONY: jupyter-notebook
jupyter-notebook:
	cd notebooks
	poetry run jupyter notebook --config=config.py --notebook-dir=notebooks


## Tests/linting/docs

.PHONY: test
## Test via tox in poetry env
test: clean
	poetry run pytest

.PHONY: coverage
## Test via tox in poetry env
coverage: clean
	poetry run pytest --cov-report xml --durations=20 --cov=bqss tests/

.PHONY: lint
## Run full static analysis suite for local development
lint:
	$(MAKE) pre-commit

.PHONY: pre-commit
## Lint using pre-commit hooks (see `.pre-commit-config.yaml`)
pre-commit:
	poetry run pre-commit run $(PRECOMMIT_HOOK_ID) --all-files

.PHONY: pre-commit-%
## Lint using a single specific pre-commit hook (see `.pre-commit-config.yaml`)
pre-commit-%: export SKIP= # Reset `SKIP` env var to force single hooks to always run
pre-commit-%:
	$(MAKE) pre-commit PRECOMMIT_HOOK_ID=$*

.PHONY: docs-%
## Build documentation in the format specified after `-`
## e.g.,
## `make docs-html` builds the docs in HTML format,
## `make docs-clean` cleans the docs build directory
docs-%:
	$(MAKE) $* -C docs

.PHONY: test-docs
## Test documentation format/syntax
test-docs:
	poetry run sphinx-build -n -T -W -b html -d tmpdir/doctrees docs/source docs/_build/html
	poetry run sphinx-build -n -T -W -b doctest -d tmpdir/doctrees docs/source docs/_build/html

#################################################################################
# Self Documenting Commands                                                     #
#################################################################################

.DEFAULT_GOAL := help

# Inspired by <http://marmelab.com/blog/2016/02/29/auto-documented-makefile.html>
# sed script explained:
# /^##/:
# 	* save line in hold space
# 	* purge line
# 	* Loop:
# 		* append newline + line to hold space
# 		* go to next line
# 		* if line starts with doc comment, strip comment character off and loop
# 	* remove target prerequisites
# 	* append hold space (+ newline) to line
# 	* replace newline plus comments by `---`
# 	* print line
# Separate expressions are necessary because labels cannot be delimited by
# semicolon; see <http://stackoverflow.com/a/11799865/1968>
export DESCRIPTION
.PHONY: help
help:
ifdef DESCRIPTION
	@echo "$$(tput bold)Description:$$(tput sgr0)" && echo "$$DESCRIPTION" && echo
endif
	@echo "$$(tput bold)Available rules:$$(tput sgr0)"
	@echo
	@sed -n -e "/^## / { \
		h; \
		s/.*//; \
		:doc" \
		-e "H; \
		n; \
		s/^## //; \
		t doc" \
		-e "s/:.*//; \
		G; \
		s/\\n## /---/; \
		s/\\n/ /g; \
		p; \
	}" ${MAKEFILE_LIST} \
	| LC_ALL='C' sort --ignore-case \
	| awk -F '---' \
		-v ncol=$$(tput cols) \
		-v indent=19 \
		-v col_on="$$(tput setaf 6)" \
		-v col_off="$$(tput sgr0)" \
	'{ \
		printf "%s%*s%s ", col_on, -indent, $$1, col_off; \
		n = split($$2, words, " "); \
		line_length = ncol - indent; \
		for (i = 1; i <= n; i++) { \
			line_length -= length(words[i]) + 1; \
			if (line_length <= 0) { \
				line_length = ncol - indent - length(words[i]) - 1; \
				printf "\n%*s ", -indent, " "; \
			} \
			printf "%s ", words[i]; \
		} \
		printf "\n"; \
	}' \
	| more $(shell test $(shell uname) = Darwin && echo '--no-init --raw-control-chars')
